=== modified file 'rules/convert/methods_attributes.rules'
--- rules/convert/methods_attributes.rules	2020-01-21 14:39:51 +0000
+++ rules/convert/methods_attributes.rules	2020-02-25 17:13:50 +0000
@@ -462,6 +462,7 @@
 ** 215 MAG 20191127          Added TabSet TabIndex property.
 **                           Added TabSet MultiLine property.
 **                           Added TabSet show() method.
+** 216 SBI 20200225          Added Calendar widget support.
 */
  -->
  
@@ -943,7 +944,10 @@
          <rule>list.put(prog.kw_att_file, execLib("cr_descr", "EmailSender"                , "attachFile"             , ""                       , true       ))</rule>
          <rule>list.put(prog.kw_att_url , execLib("cr_descr", "EmailSender"                , "attachURL"              , ""                       , true       ))</rule>
          <rule>list.put(prog.kw_build_tr, execLib("cr_descr", "TreeFace"                   , "isBuildingTree"         , "setBuildingTree"        , true       ))</rule>
+         <rule>list.put(prog.kw_calcufmt, execLib("cr_descr", "Calendar"                   , "getCustomFormat"        , "setCustomFormat"        , true       ))</rule>
+         <rule>list.put(prog.kw_calfmtst, execLib("cr_descr", "Calendar"                   , "getFormatStyle"         , "setFormatStyle"         , true       ))</rule>
          <rule>list.put(prog.kw_callback, execLib("cr_descr", "FWDTimer"                   , "getCallback"            , "setCallback"            , true       ))</rule>
+         <rule>list.put(prog.kw_calvalue, execLib("cr_descr", "Calendar"                   , "getDateTimeValue"       , "setDateTimeValue"       , true       ))</rule>
          <rule>list.put(prog.kw_cease   , execLib("cr_descr", "FWDTimer"                   , "cease"                  , null                     , true       ))</rule>
          <rule>list.put(prog.kw_clr_all , execLib("cr_descr", "TreeFace"                   , "clearAll"               , null                     , true       ))</rule>
          <rule>list.put(prog.kw_clr_attl, execLib("cr_descr", "EmailSender"                , "clearAttachmentsList"   , ""                       , true       ))</rule>
@@ -1026,6 +1030,8 @@
          <rule>list.put(prog.kw_is_c_vis, execLib("cr_descr", "TreeList"                   , "isColumnVisible"        , null                     , true       ))</rule>
          <rule>list.put(prog.kw_is_msel , execLib("cr_descr", "TreeFace"                   , "isMultiSelect"          , null                     , true       ))</rule>
          <rule>list.put(prog.kw_is_n_exp, execLib("cr_descr", "TreeFace"                   , "isNodeExpanded"         , null                     , true       ))</rule>
+         <rule>list.put(prog.kw_msicon,   execLib("cr_descr", "WidgetExtension"            , "getMouseIcon"           , "setMouseIcon"        , true       ))</rule>
+         <rule>list.put(prog.kw_mspntnum, execLib("cr_descr", "WidgetExtension"            , "getMousePointerNum"     , "setMousePointerNum"     , true       ))</rule>
          <rule>list.put(prog.kw_m_d_i_p,  execLib("cr_descr", "TreeList"                   , "moveDownInParent"       , null                     , true       ))</rule>
          <rule>list.put(prog.kw_m_u_i_p,  execLib("cr_descr", "TreeList"                   , "moveUpInParent"         , null                     , true       ))</rule>
          <rule>list.put(prog.kw_n_height, execLib("cr_descr", "TreeFace"                   , "getNodeHeight"          , "setNodeHeight"          , true       ))</rule>
@@ -1058,10 +1064,7 @@
          <rule>list.put(prog.kw_pb_enabl, execLib("cr_descr", "ProgressBar"                , "isEnabled"              , "setEnabled"             , true       ))</rule>
          <rule>list.put(prog.kw_pb_max,   execLib("cr_descr", "ProgressBar"                , "getMax"                 , "setMax"                 , true       ))</rule>
          <rule>list.put(prog.kw_pb_min,   execLib("cr_descr", "ProgressBar"                , "getMin"                 , "setMin"                 , true       ))</rule>
-         <rule>list.put(prog.kw_pb_msico, execLib("cr_descr", "ProgressBar"                , "getMouseIcon"           , "setMouseIcon"           , true       ))</rule>
-         <rule>list.put(prog.kw_pb_mspnt, execLib("cr_descr", "ProgressBar"                , "getProgBarMousePointer" , "setProgBarMousePointer" , true       ))</rule>
          <rule>list.put(prog.kw_pb_orien, execLib("cr_descr", "ProgressBar"                , "getOrientation"         , "setOrientation"         , true       ))</rule>
-         <rule>list.put(prog.kw_pb_rfrsh, execLib("cr_descr", "ProgressBar"                , "progBarRefresh"         , null                     , true       ))</rule>
          <rule>list.put(prog.kw_pb_scrol, execLib("cr_descr", "ProgressBar"                , "getScrolling"           , "setScrolling"           , true       ))</rule>
          <rule>list.put(prog.kw_pb_value, execLib("cr_descr", "ProgressBar"                , "getValue"               , "setValue"               , true       ))</rule>
          <rule>list.put(prog.kw_rem_noco, execLib("cr_descr", "TreeFace"                   , "getRemoveNodeOnCollapse", "setRemoveNodeOnCollapse", true       ))</rule>
@@ -1069,6 +1072,7 @@
          <rule>list.put(prog.kw_report,   execLib("cr_descr", "FwdReport"                  , "getReport"              , "setReport"              , true       ))</rule>
          <rule>list.put(prog.kw_res_base, execLib("cr_descr", "HtmlBrowser"                , "getResourceBase"        , "setResourceBase"        , true       ))</rule>
          <rule>list.put(prog.kw_resort,   execLib("cr_descr", "TreeList"                   , "resort"                 , null                     , true       ))</rule>
+         <rule>list.put(prog.kw_rfrsh_ui, execLib("cr_descr", "WidgetExtension"            , "refreshUI"              , null                     , true       ))</rule>
          <rule>list.put(prog.kw_rpt_csv,  execLib("cr_descr", "FwdReport"                  , "exportReportCsv"        , null                     , true       ))</rule>
          <rule>list.put(prog.kw_rpt_dsgn, execLib("cr_descr", "FwdReport"                  , "getReportDesign"        , "setReportDesign"        , true       ))</rule>
          <rule>list.put(prog.kw_rpt_html, execLib("cr_descr", "FwdReport"                  , "exportReportHtml"       , null                     , true       ))</rule>

=== modified file 'rules/convert/ui_statements.rules'
--- rules/convert/ui_statements.rules	2020-01-29 14:38:53 +0000
+++ rules/convert/ui_statements.rules	2020-02-24 18:12:00 +0000
@@ -968,6 +968,10 @@
             <action>explicitw = "DialogBox"</action>
          </rule>
          <rule>explicitw == null and 
+               (downPath("KW_CALENDAR") or evalLib("match_widget_type", "calendar"))
+            <action>explicitw = "Calendar"</action>
+         </rule>
+         <rule>explicitw == null and 
                (downPath("KW_EDITOR") or evalLib("match_widget_type", "editor"))
             <action>explicitw = "Editor"</action>
          </rule>

=== modified file 'rules/gaps/expressions.rules'
--- rules/gaps/expressions.rules	2020-01-21 14:39:51 +0000
+++ rules/gaps/expressions.rules	2020-02-24 19:29:54 +0000
@@ -1739,6 +1739,7 @@
          
          <rule>widAndQual.put(prog.kw_as       , rw.cvt_lvl_full       | rw.rt_lvl_full)</rule>
          <rule>widAndQual.put(prog.kw_browse   , rw.cvt_lvl_full       | rw.rt_lvl_full)</rule>
+         <rule>widAndQual.put(prog.kw_calendar , rw.cvt_lvl_partial    | rw.rt_lvl_partial)</rule>
          <rule>widAndQual.put(prog.kw_tabset   , rw.cvt_lvl_partial    | rw.rt_lvl_partial)</rule>
          <rule>widAndQual.put(prog.kw_img_list , rw.cvt_lvl_partial    | rw.rt_lvl_partial)</rule>
          <rule>widAndQual.put(prog.kw_treelist , rw.cvt_lvl_full       | rw.rt_lvl_partial)</rule>
@@ -2032,12 +2033,12 @@
          <rule>map.put(prog.kw_pb_appea, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
          <rule>map.put(prog.kw_pb_brsty, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
          <rule>map.put(prog.kw_pb_enabl, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
-         <rule>map.put(prog.kw_pb_msico, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
-         <rule>map.put(prog.kw_pb_mspnt, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
+         <rule>map.put(prog.kw_msicon,   rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
+         <rule>map.put(prog.kw_mspntnum, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
          <rule>map.put(prog.kw_pb_max,   rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
          <rule>map.put(prog.kw_pb_min,   rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
          <rule>map.put(prog.kw_pb_orien, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
-         <rule>map.put(prog.kw_pb_rfrsh, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
+         <rule>map.put(prog.kw_rfrsh_ui, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
          <rule>map.put(prog.kw_pb_scrol, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
          <rule>map.put(prog.kw_pb_value, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>
          <rule>map.put(prog.kw_ole_drag, rw.cvt_lvl_full    | rw.rt_lvl_full)</rule>

=== modified file 'src/com/goldencode/p2j/uast/progress.g'
--- src/com/goldencode/p2j/uast/progress.g	2020-01-21 14:39:51 +0000
+++ src/com/goldencode/p2j/uast/progress.g	2020-02-25 17:19:38 +0000
@@ -2086,7 +2086,8 @@
 ** 382 MAG 20191127          Added TabSet TabIndex property.
 **                           Added TabSet MULTILINE property.
 **                           Added TabSet show() method.
-*/                             
+** 384 SBI 20200225          Added Calendar widget support.
+*/
 
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -4320,6 +4321,8 @@
       KW_MOV_2_B;
       KW_MOV_2_T;
       KW_MOV_2EOF;
+      KW_MSICON;    // FWD extension, not real 4GL! WidgetExtension:MOUSE-ICON
+      KW_MSPNTNUM;    // FWD extension, not real 4GL! WidgetExtension:MOUSE-POINTER-NUM
       KW_MTIME;
       KW_MULT_CMP;
       KW_MULTIPLE;
@@ -4599,6 +4602,7 @@
       KW_RET_2SD;
       KW_RETURNS;
       KW_REV_FROM;
+      KW_RFRSH_UI;    // FWD extension, not real 4GL! WidgetExtension:REFRESH-UI
       KW_RGB_VAL;
       KW_RIGHT;
       KW_RIGHT_AL;
@@ -5183,7 +5187,7 @@
          KW_IL_OVER;
          KW_IL_UMASK;
          KW_ADD_IMG;    // end IMAGELIST
-         KW_MS_CLICK;   // begin PROGESS-BAR
+         KW_MS_CLICK;   // begin PROGRESS-BAR
          KW_MS_DOWN;
          KW_MS_MOVE;
          KW_MS_UP;
@@ -5214,11 +5218,17 @@
          KW_PB_MIN;
          KW_PB_MAX;
          KW_PB_VALUE;
-         KW_PB_RFRSH;
          KW_PB_SCROL;
-         KW_PB_MSPNT;
-         KW_PB_MSICO;
-         KW_COM_DATA;    // end PROGESS-BAR
+         KW_COM_DATA;    // end PROGRESS-BAR
+         KW_CALBGCLR;    // CALENDAR:CalendarBackColor
+         KW_CALFGCLR;    // CALENDAR:CalendarForeColor
+         KW_CALTITBG;    // CALENDAR:TitleBackColor
+         KW_CALTITFG;    // CALENDAR:TitleForeColor
+         KW_CALTRLFG;    // CALENDAR:TrailingForeColor
+         KW_CALENDAR;    // CALENDAR
+         KW_CALCUFMT;    // CALENDAR:CustomFormat
+         KW_CALFMTST;    // CALENDAR:FormatStyle
+         KW_CALVALUE;    // CALENDAR:DateTimeValue
       END_FWD_EXTENSION;
    END_UNRESERVED;
    BEGIN_CALLGRAPH;
@@ -8069,9 +8079,17 @@
       attrsAndMethods.put( KW_BYTES_R , ATTR_INT     );
       attrsAndMethods.put( KW_BYTES_W , ATTR_INT     );
       attrsAndMethods.put( KW_CACHE,    ATTR_INT     );
+      attrsAndMethods.put( KW_CALBGCLR, ATTR_INT     ); // FWD CALENDAR extension, not real 4GL
+      attrsAndMethods.put( KW_CALCUFMT, ATTR_CHAR    ); // FWD CALENDAR:CustomFormat extension, not real 4GL
+      attrsAndMethods.put( KW_CALFGCLR, ATTR_INT     ); // FWD CALENDAR extension, not real 4GL
+      attrsAndMethods.put( KW_CALFMTST, ATTR_INT     ); // FWD CALENDAR:FormatStyle extension, not real 4GL
+      attrsAndMethods.put( KW_CALVALUE, ATTR_CHAR    ); // FWD CALENDAR:DateTimeValue extension, not real 4GL
       attrsAndMethods.put( KW_CALL_NAM, ATTR_CHAR    );
       attrsAndMethods.put( KW_CALL_TYP, ATTR_INT     );
       attrsAndMethods.put( KW_CALLBACK, ATTR_CHAR    ); // FWD TIMER extension
+      attrsAndMethods.put( KW_CALTITBG, ATTR_INT     ); // FWD CALENDAR extension, not real 4GL
+      attrsAndMethods.put( KW_CALTITFG, ATTR_INT     ); // FWD CALENDAR extension, not real 4GL
+      attrsAndMethods.put( KW_CALTRLFG, ATTR_INT     ); // FWD CALENDAR extension, not real 4GL
       attrsAndMethods.put( KW_CANC_BRK, METH_LOGICAL );
       attrsAndMethods.put( KW_CANCEL_B, ATTR_HANDLE  );
       attrsAndMethods.put( KW_CANCEL_R, METH_LOGICAL );
@@ -8662,8 +8680,10 @@
       attrsAndMethods.put( KW_MIN_VAL , ATTR_INT     );
       attrsAndMethods.put( KW_MIN_W_C , ATTR_DEC     );
       attrsAndMethods.put( KW_MIN_W_P , ATTR_INT     );
+      attrsAndMethods.put( KW_MSICON,   ATTR_CHAR    ); // FWD extension, not real 4GL
       attrsAndMethods.put( KW_MSG_AREA, ATTR_LOGICAL );
       attrsAndMethods.put( KW_MSG_AFNT, ATTR_INT     );
+      attrsAndMethods.put( KW_MSPNTNUM, ATTR_INT     ); // FWD extension, not real 4GL
       attrsAndMethods.put( KW_MNEMON,   ATTR_INT     ); // FWD extension, not real 4GL!
       attrsAndMethods.put( KW_MODIFIED, ATTR_LOGICAL );
       attrsAndMethods.put( KW_MOU_PTR , ATTR_CHAR    );
@@ -8786,10 +8806,7 @@
       attrsAndMethods.put( KW_PB_ENABL, ATTR_LOGICAL ); // FWD PROGRESS-BAR extension, not real 4GL
       attrsAndMethods.put( KW_PB_MAX,   ATTR_DEC     ); // FWD PROGRESS-BAR extension, not real 4GL
       attrsAndMethods.put( KW_PB_MIN,   ATTR_DEC     ); // FWD PROGRESS-BAR extension, not real 4GL
-      attrsAndMethods.put( KW_PB_MSICO, ATTR_CHAR    ); // FWD PROGRESS-BAR extension, not real 4GL
-      attrsAndMethods.put( KW_PB_MSPNT, ATTR_INT     ); // FWD PROGRESS-BAR extension, not real 4GL
       attrsAndMethods.put( KW_PB_ORIEN, ATTR_INT     ); // FWD PROGRESS-BAR extension, not real 4GL
-      attrsAndMethods.put( KW_PB_RFRSH, METH_VOID    ); // FWD PROGRESS-BAR extension, not real 4GL
       attrsAndMethods.put( KW_PB_SCROL, ATTR_INT     ); // FWD PROGRESS-BAR extension, not real 4GL
       attrsAndMethods.put( KW_PB_VALUE, ATTR_DEC     ); // FWD PROGRESS-BAR extension, not real 4GL
       attrsAndMethods.put( KW_PREF_DS , ATTR_LOGICAL );
@@ -8871,6 +8888,7 @@
       attrsAndMethods.put( KW_REPOS_2R, METH_LOGICAL );
       attrsAndMethods.put( KW_REPOS_2I, METH_LOGICAL );
       attrsAndMethods.put( KW_REQ_INFO, ATTR_CLASS   );
+      attrsAndMethods.put( KW_RFRSH_UI, METH_VOID    ); // FWD extension, not real 4GL
       attrsAndMethods.put( KW_RSP_INFO, ATTR_CLASS   );
       attrsAndMethods.put( KW_RES_BASE, ATTR_CHAR    ); // FWD extension, not real 4GL
       attrsAndMethods.put( KW_RESET   , METH_LOGICAL );
@@ -24472,6 +24490,7 @@
          | KW_COMBO_BX   { is_widget = true; }
          | KW_CNTRL_FR   { is_widget = true; }
          | KW_DIALOG     { is_widget = true; }
+         | KW_CALENDAR   { is_widget = true; }
          | KW_EDITOR     { is_widget = true; }
          | KW_FILL_IN    { is_widget = true; }
          | KW_FRAME      { is_widget = true; }
@@ -33137,6 +33156,9 @@
          new Keyword("bytes-written"                  ,  0, KW_BYTES_W , false),
          new Keyword("cache"                          ,  0, KW_CACHE   , false),
          new Keyword("cache-size"                     ,  0, KW_CACHE_SZ, false),
+         new Keyword("calendar"                       ,  0, KW_CALENDAR, false), // FWD CALENDAR extension, not a real 4GL keyword
+         new Keyword("CalendarBackColor"              ,  0, KW_CALBGCLR, false), // FWD CALENDAR extension
+         new Keyword("CalendarForeColor"              ,  0, KW_CALFGCLR, false), // FWD CALENDAR extension
          new Keyword("call"                           ,  0, KW_CALL    , true ),
          new Keyword("call-name"                      ,  0, KW_CALL_NAM, false),
          new Keyword("call-type"                      ,  0, KW_CALL_TYP, false),
@@ -33323,6 +33345,7 @@
          new Keyword("cursor-offset"                  ,  0, KW_CUR_OFF , false),
          new Keyword("cursor-right"                   ,  0, KW_CUR_RGHT, false),  // missing in keyword index, found elsewhere in lang ref
          new Keyword("cursor-up"                      ,  0, KW_CUR_UP  , false),  // missing in keyword index, found elsewhere in lang ref
+         new Keyword("CustomFormat"                   ,  0, KW_CALCUFMT, false),  // CALENDAR:CustomFormat extension
          new Keyword("cut"                            ,  0, KW_CUT     , false),  // missing in keyword index, found in prog handbook as a key function
          new Keyword("data-bind"                      ,  0, KW_DATA_BND, false),
          new Keyword("data-entry-return"              , 14, KW_DATA_E_R, false),
@@ -33338,6 +33361,7 @@
          new Keyword("dataset-handle"                 ,  0, KW_DSET_HND, true ),
          new Keyword("date"                           ,  0, KW_DATE    , false),
          new Keyword("datetime"                       ,  0, KW_DATETIME, false),  // missing from keyword index and UNTESTED at this time
+         new Keyword("DateTimeValue"                  ,  0, KW_CALVALUE, false),  // CALENDAR:VALUE extension
          new Keyword("datetime-tz"                    ,  0, KW_DATE_TZ , false),  // missing from keyword index and UNTESTED at this time
          new Keyword("date-format"                    ,  6, KW_DATE_FMT, false),
          new Keyword("date-separator"                 ,  0, KW_DATE_SEP, false),  // FWD extension, not a real 4GL keyword
@@ -33645,6 +33669,7 @@
          new Keyword("form-long-input"                ,  0, KW_FORM_LIN, false),
          new Keyword("format"                         ,  4, KW_FORMAT  , true ),  // handles "separate keyword" form too
          new Keyword("format-datetime"                ,  0, KW_FMT_DT  , false),  // not a real keyword, but is normally defined in the PSC webspeed 4GL code
+         new Keyword("FormatStyle"                    ,  0, KW_CALFMTST, false),  // FWD extension for CALENDAR:FormatStyle, not a real 4GL keyword
          new Keyword("formatted"                      ,  8, KW_FORMATTE, false),
          new Keyword("forward-only"                   ,  0, KW_FWD_ONLY, false),  // missing from keyword index and UNTESTED at this time
          new Keyword("forwards"                       ,  7, KW_FORWARD , false),  // handles "separate keyword" forward too
@@ -34384,6 +34409,8 @@
          new Keyword("object"                         ,  0, KW_OBJECT  , false),
          new Keyword("octet-length"                   ,  0, KW_OCT_LEN , false),
          new Keyword("ocx-mouse-button"               ,  0, KW_OCX_MBTN, false),  // FWD extension, not a real 4GL keyword
+         new Keyword("mouse-icon"                     ,  0, KW_MSICON,   false),  // FWD WidgetExtension extension, not a real 4GL keyword
+         new Keyword("mouse-pointer-num"              ,  0, KW_MSPNTNUM, false),  // FWD WidgetExtension extension, not a real 4GL keyword
          new Keyword("ocx-mouse-shift"                ,  0, KW_OCX_MSHT, false),  // FWD extension, not a real 4GL keyword
          new Keyword("ocx-mouse-x"                    ,  0, KW_OCX_MSX , false),  // FWD extension, not a real 4GL keyword
          new Keyword("ocx-mouse-y"                    ,  0, KW_OCX_MSY , false),  // FWD extension, not a real 4GL keyword
@@ -34547,12 +34574,9 @@
          new Keyword("pb-appearance"                  ,  0, KW_PB_APPEA, false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
          new Keyword("pb-border-style"                ,  0, KW_PB_BRSTY, false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
          new Keyword("pb-enabled"                     ,  0, KW_PB_ENABL, false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
-         new Keyword("pb-mouse-icon"                  ,  0, KW_PB_MSICO, false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
-         new Keyword("pb-mouse-pointer"               ,  0, KW_PB_MSPNT, false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
          new Keyword("pb-max"                         ,  0, KW_PB_MAX  , false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
          new Keyword("pb-min"                         ,  0, KW_PB_MIN  , false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
          new Keyword("pb-orientation"                 ,  0, KW_PB_ORIEN, false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
-         new Keyword("pb-refresh"                     ,  0, KW_PB_RFRSH, false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
          new Keyword("pb-scrolling"                   ,  0, KW_PB_SCROL, false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
          new Keyword("pb-value"                       ,  0, KW_PB_VALUE, false),  // FWD PROGRESS-BAR extension, not a real 4GL keyword
          new Keyword("progress-source"                , 10, KW_PROG_SRC, false),
@@ -34622,6 +34646,7 @@
          new Keyword("refresh"                        ,  0, KW_REFRESH , false),
          new Keyword("refresh-audit-policy"           ,  0, KW_REFR_A_P, false),
          new Keyword("refreshable"                    ,  0, KW_REFRABLE, false),
+         new Keyword("refresh-ui"                     ,  0, KW_RFRSH_UI, false),  // FWD WidgetExtension extension, not a real 4GL keyword
          new Keyword("register-domain"                ,  0, KW_REG_DMN , false),
          new Keyword("reject-changes"                 ,  0, KW_REJ_CHGS, false),  // missing from keyword index and UNTESTED at this time
          new Keyword("reject-row-changes"             ,  0, KW_REJ_RCHG, false),  // missing from keyword index and UNTESTED at this time
@@ -35083,6 +35108,9 @@
          new Keyword("ttcodepage"                     ,  0, KW_TTCP    , false),  // missing from keyword index and UNTESTED at this time
          new Keyword("type"                           ,  0, KW_TYPE    , false),
          new Keyword("type-of"                        ,  0, KW_TYPE_OF , false),
+         new Keyword("TitleBackColor"                 ,  0, KW_CALTITBG, false),  // CALENDAR:TitleBackColor
+         new Keyword("TitleForeColor"                 ,  0, KW_CALTITFG, false),  // CALENDAR:TitleForeColor
+         new Keyword("TrailingForeColor"              ,  0, KW_CALTRLFG, false),  // CALENDAR:TrailingForeColor
          new Keyword("unbox"                          ,  6, KW_UNBOX   , false),
          new Keyword("unbuffered"                     ,  6, KW_UNBUF   , false),
          new Keyword("undo"                           ,  0, KW_UNDO    , true ),

